SystemOrganization addCategory: #ConfigurationOfTopFeeder!

Object subclass: #ConfigurationOfTopFeeder
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfTopFeeder'!

!ConfigurationOfTopFeeder class methodsFor: 'private' stamp: 'NickAger 3/26/2012 15:48'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfTopFeeder class methodsFor: 'private' stamp: 'NickAger 3/26/2012 15:48'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfTopFeeder class methodsFor: 'metacello tool support' stamp: 'NickAger 3/26/2012 15:48'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfTopFeeder class methodsFor: 'loading' stamp: 'NickAger 3/26/2012 15:48'!
load
	"self load"
	
	self project stableVersion load! !

!ConfigurationOfTopFeeder class methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 15:48'!
project

	^self new project! !

!ConfigurationOfTopFeeder methodsFor: 'baselines' stamp: 'NickAger 3/27/2012 18:28'!
baseline100: spec 
	<version: '1.0.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: '26th March 2012'.
		spec 
			repository: 'http://ss3.gemstone.com/ss/TopFeeder'.
		spec
			project: 'Magritte AddOns' with: [
				spec
					className: 'ConfigurationOfMagritte3AddOns';
					loads: #('default');
					versionString: #stable;
					file: 'ConfigurationOfMagritte3';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			yourself.
		spec
			project: 'Pier Core' with: [
				spec
					className: 'ConfigurationOfPier3';
					versionString: #stable;
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			yourself.
			
		spec	
			project: 'Zinc' with: [
				spec
					className: 'ConfigurationOfZincHTTPComponents';
					versionString: #'stable';
					loads: #('Zinc-HTTP' );
					repository: 'http://www.squeaksource.com/ZincHTTPComponents' ];
			yourself.
			
		spec
		 	package: 'TopFeeder-Magritte-Description' with: [ 
				spec requires: #( 'Magritte AddOns');
				yourself ];
			package: 'TopFeeder-Model' with: [ 
				spec requires: #( 'TopFeeder-Magritte-Description'  'Magritte AddOns' 'Zinc');
				yourself ];
			package: 'TopFeeder-Tests' with: [ 
				spec requires: #( 'TopFeeder-Model' 'TopFeeder-Magritte-Description');
				yourself ];
			package: 'TopFeeder-Pier-Widgets'  with: [ 
				spec requires: #( 'Pier Core');
				yourself ];
			yourself.
		spec
			group: 'default' with: #('TopFeeder-Model' 'TopFeeder-Magritte-Description');
			group: 'Tests' with: #('TopFeeder-Tests');
			group: 'Pier' with: #('TopFeeder-Pier-Widgets');
			yourself.
		].
	spec for: #squeakCommon do: [
	].
	spec for: #gemstone do: [
	].! !

!ConfigurationOfTopFeeder methodsFor: 'symbolic versions' stamp: 'NickAger 3/26/2012 15:48'!
development: spec 
	"no development versions at the moment"
	
	<symbolicVersion: #development>! !

!ConfigurationOfTopFeeder methodsFor: 'accessing' stamp: 'NickAger 3/26/2012 15:48'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear ]! !

!ConfigurationOfTopFeeder methodsFor: 'symbolic versions' stamp: 'NickAger 3/26/2012 16:05'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'common' version: '1.0.0'. ! !

!ConfigurationOfTopFeeder methodsFor: 'versions' stamp: 'NickAger 3/27/2012 13:34'!
version100: spec
	<version: '1.0.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'initial release of top feeder'.
		spec author: 'NickAger'.
		spec timestamp: '26th March 2012'.
		
		spec 
			package: 'TopFeeder-Magritte-Description' with: 'TopFeeder-Magritte-Description-NickAger.3';
			package: 'TopFeeder-Tests' with: 'TopFeeder-Tests-NickAger.1';
			package: 'TopFeeder-Model' with: 'TopFeeder-Model-NickAger.2';
			package: 'TopFeeder-Pier-Widgets' with: 'TopFeeder-Pier-Widgets-NickAger.1' ].
		
	spec for: #'squeakCommon' do: [
	].
	spec for: #'gemstone' do: [
	].! !
